## ciftilib 1.5.1

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)

#UseDoxygen trips over a policy change in cmake 3, suppress the warning
CMAKE_POLICY(VERSION 2.8.7)
#the suggested version-type policy command doesn't shut this warning up, so set it manually
IF (POLICY CMP0045)
    CMAKE_POLICY(SET CMP0045 OLD)
ENDIF (POLICY CMP0045)

PROJECT(CiftiLib)

SET(CIFTILIB_VERSION 1.5)

#MSVC seems like the only compiler that chokes on -W -Wall
IF (NOT MSVC)
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -W -Wall")
ENDIF (NOT MSVC)

SET(IGNORE_QT FALSE CACHE BOOL "don't try to use QT")

SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules/" "${CMAKE_SOURCE_DIR}/cmake/Modules/UseDoxygen/")

INCLUDE(UseDoxygen)

#QT
IF (NOT IGNORE_QT)
    FIND_PACKAGE(Qt4 4.8.0 QUIET)
    IF (QT_FOUND)
        SET(QT_DONT_USE_QTGUI TRUE)
        ADD_DEFINITIONS(-DCIFTILIB_USE_QT)
        INCLUDE(${QT_USE_FILE})
        SET(LIBS ${LIBS} ${QT_LIBRARIES})
        #for pkg-config file
        SET(CIFTILIB_PKGCONFIG_REQUIRES_LINE "Requires: QtCore >= 4.8.0 QtXml")
        SET(CIFTILIB_PKGCONFIG_DEFINE "-DCIFTILIB_USE_QT")
    ELSE (QT_FOUND)
        FIND_PACKAGE(Qt5Core)
        IF (Qt5Core_FOUND)
            SET(QT_FOUND TRUE)
            INCLUDE_DIRECTORIES(${Qt5Core_INCLUDE_DIRS})
            SET(LIBS ${LIBS} Qt5::Core)
            #whatever that means
            ADD_DEFINITIONS(-DCIFTILIB_USE_QT)
            SET(CIFTILIB_PKGCONFIG_REQUIRES_LINE "Requires: Qt5Core Qt5Xml")
            SET(CIFTILIB_PKGCONFIG_DEFINE "-DCIFTILIB_USE_QT")
        ENDIF (Qt5Core_FOUND)
    ENDIF (QT_FOUND)
ENDIF (NOT IGNORE_QT)

#alternative to QT xml, string
IF (NOT QT_FOUND)
    FIND_PACKAGE(libxml++ 2.17.0 REQUIRED)
    INCLUDE_DIRECTORIES(${libxml++_INCLUDE_DIRS})
    SET(LIBS ${LIBS} ${libxml++_LIBRARIES})
    ADD_DEFINITIONS(-DCIFTILIB_USE_XMLPP)
    #for pkg-config file
    SET(CIFTILIB_PKGCONFIG_REQUIRES_LINE "Requires: libxml++-2.6 >= 2.17.0")
    SET(CIFTILIB_PKGCONFIG_DEFINE "-DCIFTILIB_USE_XMLPP")
ENDIF (NOT QT_FOUND)

#boost, including filesystem if not using QT
IF (NOT QT_FOUND)
    FIND_PACKAGE(Boost REQUIRED COMPONENTS filesystem system)
ELSE (NOT QT_FOUND)
    FIND_PACKAGE(Boost REQUIRED)
ENDIF (NOT QT_FOUND)
INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIRS})
SET(LIBS ${LIBS} ${Boost_LIBRARIES})
#boost quirks
IF (Boost_VERSION LESS 104400)
    #absolute() was added in 1.44.0, with filesystem v3
    ADD_DEFINITIONS(-DCIFTILIB_BOOST_NO_FSV3)
ENDIF (Boost_VERSION LESS 104400)
IF (Boost_VERSION LESS 104800)
    #canonical() was added in 1.48.0
    ADD_DEFINITIONS(-DCIFTILIB_BOOST_NO_CANONICAL)
ENDIF (Boost_VERSION LESS 104800)
IF (Boost_VERSION LESS 105600)
    #try_lexical_cast was added in 1.56.0
    ADD_DEFINITIONS(-DCIFTILIB_BOOST_NO_TRY_LEXICAL)
ENDIF (Boost_VERSION LESS 105600)

#zlib, useful for volume reading
FIND_PACKAGE(ZLIB)
IF (ZLIB_FOUND)
    INCLUDE_DIRECTORIES(${ZLIB_INCLUDE_DIRS})
    SET(LIBS ${LIBS} ${ZLIB_LIBRARIES})
    ADD_DEFINITIONS("-DCIFTILIB_HAVE_ZLIB")
ENDIF (ZLIB_FOUND)
#OS X has some weirdness in its zlib, so let the preprocessor know
IF (APPLE)
    ADD_DEFINITIONS(-DCIFTILIB_OS_MACOSX)
ENDIF (APPLE)

#openmp provides a fast mutex implementation, faster than QT (and probably faster than glibmm)
FIND_PACKAGE(OpenMP)
IF (OPENMP_FOUND)
    SET(CMAKE_CXX_FLAGS "${OpenMP_CXX_FLAGS} ${CMAKE_CXX_FLAGS}")
ENDIF (OPENMP_FOUND)

ENABLE_TESTING()

#the library source, doesn't contain build targets
ADD_SUBDIRECTORY(src)

#example directory, has build targets and tests
ADD_SUBDIRECTORY(example)

macro(append_subdir_files variable dirname)
    get_directory_property(holder DIRECTORY ${dirname} DEFINITION ${variable})
    foreach(depfile ${holder})
        list(APPEND ${variable} "${dirname}/${depfile}")
    endforeach()
endmacro()

#get the sources and install info
append_subdir_files(SOURCES src)
append_subdir_files(HEADERS src)
append_subdir_files(PUBLIC_HEADERS src)
append_subdir_files(PRIVATE_DIRS src)

ADD_LIBRARY(Cifti
${SOURCES}
${HEADERS}
)

#one way to get qt5's new compiler flag restrictions into the build - does it have other consequences?
TARGET_LINK_LIBRARIES(Cifti ${LIBS})

#NOTE: soversion set to 0 because ABI compatibility was not designed into the interface
#soversion defines what symlinks are created, version defines what to put on the end of the actual library file
SET_TARGET_PROPERTIES(Cifti
PROPERTIES
OUTPUT_NAME Cifti
SOVERSION 0
VERSION ${CIFTILIB_VERSION}
)

INCLUDE_DIRECTORIES(
${CMAKE_SOURCE_DIR}/src
)

#install dirs
INCLUDE(GNUInstallDirs)

#pkg-config
CONFIGURE_FILE(CiftiLib.pc.in CiftiLib.pc @ONLY)
INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/CiftiLib.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

#install
INSTALL(TARGETS Cifti DESTINATION ${CMAKE_INSTALL_LIBDIR})
INSTALL(FILES ${PUBLIC_HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/CiftiLib)
INSTALL(DIRECTORY ${PRIVATE_DIRS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/CiftiLib FILES_MATCHING PATTERN "*.h")

=== example/CMakeLists.txt ===

PROJECT(example)

ADD_EXECUTABLE(rewrite
rewrite.cxx)

TARGET_LINK_LIBRARIES(rewrite
Cifti
${LIBS})

ADD_EXECUTABLE(xmlinfo
xmlinfo.cxx)

TARGET_LINK_LIBRARIES(xmlinfo
Cifti
${LIBS})

INCLUDE_DIRECTORIES(
${CMAKE_SOURCE_DIR}/example
${CMAKE_SOURCE_DIR}/src
)

SET(cifti_files
Conte69.MyelinAndCorrThickness.32k_fs_LR.dscalar.nii
Conte69.MyelinAndCorrThickness.32k_fs_LR.dtseries.nii
Conte69.MyelinAndCorrThickness.32k_fs_LR.ptseries.nii
Conte69.parcellations_VGD11b.32k_fs_LR.dlabel.nii
ones.dscalar.nii
)

IF(QT_FOUND)
    #QT4
    SET(cifti_be_md5s
        3ba20f6ef590735c1211991f8e0144e6
        e3a1639ef4b354752b0abb0613eedb73
        9fd1b6fb7b938155226ca53fdaff5a12
        48903d80589d294b5421cad9a7ba9264
        93bb7f76c8d273817601ea5be236f83d
    )
    SET(cifti_le_md5s
        3e24e7908122905c2a2d357347ecee7c
        4ee31da414dcd26fe37855601ae3e9e2
        e096a1cf0713f7a36590445e9f6564b1
        32345267599b07083092b7dedfd8796c
        512e0359c64d69dde93d605f8797f3a2
    )
ELSE(QT_FOUND)
    #xml++
    SET(cifti_be_md5s
        a2581f76a94b7c4371d6970f1262e1bc
        ca4cfb02fb7f0d8f167f546aab85e91d
        892c26e691fe62c4edf358f7f91942a3
        e761d405c945e724b37f96e356dc19ad
        2e4efa4e36cdb13f514c265e6c9c8c4b
    )
    SET(cifti_le_md5s
        39ecfba4c1dade1a2ce3e95b325bd8b1
        921a42e4181052ef4f211d389a2e9328
        764c816004ebe23d188d98f9f29c7337
        6fabac021e377efd35dede7198feefd4
        fe0cbb768e26aa12a0e03990f4f50a30
    )
ENDIF(QT_FOUND)

#ADD_TEST(timer ${CMAKE_CURRENT_BINARY_DIR}/Tests/test_driver timer)

LIST(LENGTH cifti_files num_cifti_files)
#FOREACH(... RANGE x) is stupid, it does all of [0, x] inclusive, totaling x + 1 iterations
MATH(EXPR loop_end "${num_cifti_files} - 1")

FOREACH(index RANGE ${loop_end})
    LIST(GET cifti_files ${index} testfile)
    #ADD_TEST doesn't seem to have a way to capture stdout, so checking the output for consistency seems to be a problem
    ADD_TEST(info-${testfile} xmlinfo ${CMAKE_SOURCE_DIR}/example/data/${testfile})

    ADD_TEST(rewrite-little-${testfile} rewrite ${CMAKE_SOURCE_DIR}/example/data/${testfile} little-${testfile} LITTLE)
    LIST(GET cifti_le_md5s ${index} goodsum)
    ADD_TEST(rewrite-little-md5-${testfile} ${CMAKE_COMMAND} -Dgood_sum=${goodsum} -Dcheck_file=little-${testfile} -P ${CMAKE_SOURCE_DIR}/cmake/scripts/testmd5.cmake)

    ADD_TEST(rewrite-big-${testfile} rewrite ${CMAKE_SOURCE_DIR}/example/data/${testfile} big-${testfile} BIG)
    LIST(GET cifti_be_md5s ${index} goodsum)
    ADD_TEST(rewrite-big-md5-${testfile} ${CMAKE_COMMAND} -Dgood_sum=${goodsum} -Dcheck_file=big-${testfile} -P ${CMAKE_SOURCE_DIR}/cmake/scripts/testmd5.cmake)
ENDFOREACH(index RANGE ${loop_end})

=== src/CMakeLists.txt ===
PROJECT(src)

SET(HEADERS
CiftiFile.h
NiftiIO.h
)

SET(SOURCES
CiftiFile.cxx
NiftiIO.cxx
)

#only the headers that should end up in the top level of CiftiLib when installed
#do not move this below the append_subdir_files calls
SET(PUBLIC_HEADERS
${HEADERS}
)

#list the subdirectories here, so each build system file only references one additional level
SET(PRIVATE_DIRS
Cifti
Common
Nifti
)

ADD_SUBDIRECTORY(Cifti)
ADD_SUBDIRECTORY(Common)
ADD_SUBDIRECTORY(Nifti)

macro(append_subdir_files variable dirname)
    get_directory_property(holder DIRECTORY ${dirname} DEFINITION ${variable})
    foreach(depfile ${holder})
        list(APPEND ${variable} "${dirname}/${depfile}")
    endforeach()
endmacro()

append_subdir_files(SOURCES Nifti)
append_subdir_files(HEADERS Nifti)
append_subdir_files(SOURCES Cifti)
append_subdir_files(HEADERS Cifti)
append_subdir_files(SOURCES Common)
append_subdir_files(HEADERS Common)

=== src/Cifti/CMakeLists.txt ===

PROJECT(Cifti)

SET(HEADERS
CiftiXML.h
CiftiVersion.h

CiftiMappingType.h
CiftiBrainModelsMap.h
CiftiLabelsMap.h
CiftiParcelsMap.h
CiftiScalarsMap.h
CiftiSeriesMap.h

Label.h
LabelTable.h
MetaData.h

StructureEnum.h
VolumeSpace.h
)

SET(SOURCES
CiftiXML.cxx
CiftiVersion.cxx

CiftiMappingType.cxx
CiftiBrainModelsMap.cxx
CiftiLabelsMap.cxx
CiftiParcelsMap.cxx
CiftiScalarsMap.cxx
CiftiSeriesMap.cxx

Label.cxx
LabelTable.cxx
MetaData.cxx

StructureEnum.cxx
VolumeSpace.cxx
)

=== src/Common/CMakeLists.txt ===

PROJECT(Common)

SET(HEADERS
AString.h
ByteSwapping.h
CiftiAssert.h
BinaryFile.h
CiftiException.h
CiftiMutex.h
Compact3DLookup.h
CompactLookup.h
FloatMatrix.h
MatrixFunctions.h
MathFunctions.h
MultiDimArray.h
MultiDimIterator.h
Vector3D.h
VoxelIJK.h
XmlAdapter.h
)

SET(SOURCES
AString.cxx
BinaryFile.cxx
CiftiException.cxx
FloatMatrix.cxx
MathFunctions.cxx
Vector3D.cxx
XmlAdapter.cxx
)

=== src/Nifti/CMakeLists.txt ===

project (Nifti)

SET(HEADERS
NiftiHeader.h
)

SET(SOURCES
NiftiHeader.cxx
)

=== cmake/Modules/UseDoxygen/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

project(UseDoxygen)

set(CMAKE_INSTALL_PREFIX ${CMAKE_ROOT})

install(FILES UseDoxygen.cmake Doxyfile.in
	DESTINATION "Modules")

configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)

add_custom_target(uninstall
	COMMAND "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

=== debian/changelog ===
ciftilib (1.5.1-1build1) bionic; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 26 Oct 2017 17:11:17 +0000

ciftilib (1.5.1-1) unstable; urgency=low

  * Initial release. (Closes: #818983)

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Tue, 08 Nov 2016 19:21:03 +0000

=== debian/control ===
Source: ciftilib
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
Section: libs
Priority: optional
Build-Depends: cmake,
               debhelper (>= 10),
               libboost-dev,
               libboost-filesystem-dev,
               libxml++2.6-dev,
               zlib1g-dev
Build-Depends-Indep: doxygen
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/ciftilib.git
Vcs-Git: https://anonscm.debian.org/git/debian-med/ciftilib.git
Homepage: https://github.com/Washington-University/CiftiLib

Package: libcifti0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: library for manipulating CIFTI files
 CIFTI (Connectivity Informatics Technology Initiative) standardizes the file
 formats for storage of connectivity data. These formats are developed by the
 Human Connectome Project and other interested parties.
 .
 CiftiLib is a C++ library for CIFTI-1 and CIFTI-2 file I/O, supporting both
 on-disk and in-memory access. It also provides facilities for reading and
 writing generic NIfTI-1 and NIfTI-2 files.
 .
 This package provides the shared libraries.

Package: libcifti-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         libboost-dev,
         libcifti0 (= ${binary:Version}),
         libxml++2.6-dev
Suggests: libcifti-doc
Description: development files for CiftiLib
 CIFTI (Connectivity Informatics Technology Initiative) standardizes the file
 formats for storage of connectivity data. These formats are developed by the
 Human Connectome Project and other interested parties.
 .
 CiftiLib is a C++ library for CIFTI-1 and CIFTI-2 file I/O, supporting both
 on-disk and in-memory access. It also provides facilities for reading and
 writing generic NIfTI-1 and NIfTI-2 files.
 .
 This package provides the development files.

Package: libcifti-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Description: documentation for CiftiLib
 CIFTI (Connectivity Informatics Technology Initiative) standardizes the file
 formats for storage of connectivity data. These formats are developed by the
 Human Connectome Project and other interested parties.
 .
 CiftiLib is a C++ library for CIFTI-1 and CIFTI-2 file I/O, supporting both
 on-disk and in-memory access. It also provides facilities for reading and
 writing generic NIfTI-1 and NIfTI-2 files.
 .
 This package provides the documentation.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
# Prevent overlinkage with libsigc++-2.0.
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_SHARED_LIBS=ON -DIGNORE_QT=ON

override_dh_auto_build-indep:
	dh_auto_build -- doc

override_dh_installdocs-indep:
	dh_installdocs --indep
	dh_doxygen --indep

override_dh_compress-indep:
	dh_compress --indep --exclude=examples

=== debian/tests/control ===
Tests: ciftilib-tests
Depends: @, cmake, g++ | c++-compiler, pkg-config

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/CiftiLib-$1\.tar\.gz/ \
https://github.com/Washington-University/CiftiLib/tags .*/v?(\d\S*)\.tar\.gz

## ciftilib 1.5.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -41,7 +41,7 @@
             SET(LIBS ${LIBS} Qt5::Core)
             #whatever that means
             ADD_DEFINITIONS(-DCIFTILIB_USE_QT)
-            SET(CIFTILIB_PKGCONFIG_REQUIRES_LINE "Requires: Qt5Core Qt5Xml")
+            SET(CIFTILIB_PKGCONFIG_REQUIRES_LINE "Requires: Qt5Core")
             SET(CIFTILIB_PKGCONFIG_DEFINE "-DCIFTILIB_USE_QT")
         ENDIF (Qt5Core_FOUND)
     ENDIF (QT_FOUND)

=== src/Common/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,3 @@
-
-PROJECT(Common)
 
 SET(HEADERS
 AString.h

=== debian/changelog ===
ciftilib (1.5.3-3ubuntu1) focal; urgency=medium

  * Merge from Debian unstable, remaining changes:
    + Allow stderr output in autopkgtests for GCC warnings on armhf

 -- Graham Inggs <ginggs@ubuntu.com>  Sun, 12 Apr 2020 07:58:14 +0000

ciftilib (1.5.3-3) unstable; urgency=medium

  * Team upload.
  * FTBFS with Boost 1.71
    Closes: #948665
  * debhelper-compat 12
  * Standards-Version: 4.4.1
  * Remove obsolete field Name from debian/upstream/metadata (already
    present in machine-readable debian/copyright).

 -- Andreas Tille <tille@debian.org>  Sat, 11 Jan 2020 18:03:26 +0100

ciftilib (1.5.3-2ubuntu1) disco; urgency=medium

  * Allow stderr output in autopkgtests for GCC warnings on armhf

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 04 Apr 2019 13:32:13 +0000

ciftilib (1.5.3-2) unstable; urgency=medium

  * gbp.conf: drop pq settings
  * Cherry-pick upstream fix for FTBFS on big endian.
    Thanks to Adrian Bunk for reporting (Closes: #921555)

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Tue, 02 Apr 2019 21:49:25 +0200

ciftilib (1.5.3-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * debhelper 12
  * Standards-Version: 4.3.0
  * Do not run build time tests parallel

 -- Andreas Tille <tille@debian.org>  Wed, 30 Jan 2019 10:15:35 +0100

ciftilib (1.5.1-3) unstable; urgency=medium

  * Team upload
  * Fix autopkgtest after moving docs to different location
    Closes: #901832, #901833

 -- Andreas Tille <tille@debian.org>  Tue, 19 Jun 2018 09:58:56 +0200

ciftilib (1.5.1-2) unstable; urgency=medium

  * Team upload.
  * Do not run test suite for arch indep builds
    Closes: #901105
  * debhelper 11
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.1.4
  * Debhelper 11 installs docs to /usr/share/doc/libcifti-dev/

 -- Andreas Tille <tille@debian.org>  Mon, 18 Jun 2018 14:53:35 +0200

=== debian/control ===
--- 
+++ 
@@ -1,18 +1,19 @@
 Source: ciftilib
-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
 Section: libs
 Priority: optional
 Build-Depends: cmake,
-               debhelper (>= 10),
+               debhelper-compat (= 12),
                libboost-dev,
                libboost-filesystem-dev,
                libxml++2.6-dev,
                zlib1g-dev
 Build-Depends-Indep: doxygen
-Standards-Version: 3.9.8
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/ciftilib.git
-Vcs-Git: https://anonscm.debian.org/git/debian-med/ciftilib.git
+Standards-Version: 4.4.1
+Vcs-Browser: https://salsa.debian.org/med-team/ciftilib
+Vcs-Git: https://salsa.debian.org/med-team/ciftilib.git
 Homepage: https://github.com/Washington-University/CiftiLib
 
 Package: libcifti0

=== debian/rules ===
--- 
+++ 
@@ -22,3 +22,11 @@
 
 override_dh_compress-indep:
 	dh_compress --indep --exclude=examples
+
+override_dh_auto_test-indep:
+	echo "Do not run test suite for arch indep builds"
+
+override_dh_auto_test-arch:
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
+	dh_auto_test --no-parallel
+endif

## ciftilib 1.6.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -21,6 +21,22 @@
 SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules/" "${CMAKE_SOURCE_DIR}/cmake/Modules/UseDoxygen/")
 
 INCLUDE(UseDoxygen)
+
+#TSC: glibmm requires c++11, so it needs to be in the compile flags - in older cmake, this needs to be done manually
+IF (${CMAKE_VERSION} VERSION_LESS "3.1")
+    IF (CMAKE_COMPILER_IS_GNUCC)
+        include(CheckCXXCompilerFlag)
+        CHECK_CXX_COMPILER_FLAG("-std=c++11" GCC_STD11)
+        IF (${GCC_STD11})
+            SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
+        ELSE (${GCC_STD11})
+            SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
+        ENDIF (${GCC_STD11})
+    ENDIF (CMAKE_COMPILER_IS_GNUCC)
+ELSE (${CMAKE_VERSION} VERSION_LESS "3.1")
+    SET(CMAKE_CXX_STANDARD 11)
+    SET(CMAKE_CXX_STANDARD_REQUIRED TRUE)
+ENDIF (${CMAKE_VERSION} VERSION_LESS "3.1")
 
 #QT
 IF (NOT IGNORE_QT)

=== example/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,3 @@
-
-PROJECT(example)
 
 ADD_EXECUTABLE(rewrite
 rewrite.cxx)
@@ -12,6 +10,13 @@
 xmlinfo.cxx)
 
 TARGET_LINK_LIBRARIES(xmlinfo
+Cifti
+${LIBS})
+
+ADD_EXECUTABLE(datatype
+datatype.cxx)
+
+TARGET_LINK_LIBRARIES(datatype
 Cifti
 ${LIBS})
 
@@ -29,7 +34,7 @@
 )
 
 IF(QT_FOUND)
-    #QT4
+    #QT4 and QT5
     SET(cifti_be_md5s
         3ba20f6ef590735c1211991f8e0144e6
         e3a1639ef4b354752b0abb0613eedb73
@@ -43,6 +48,13 @@
         e096a1cf0713f7a36590445e9f6564b1
         32345267599b07083092b7dedfd8796c
         512e0359c64d69dde93d605f8797f3a2
+    )
+    SET(cifti_datatype_md5s
+        cca91b955b1134251d62764cb1ebf44c
+        6359af74ba6b51357aefab7de7a76097
+        10ee62309850e55936fa9f702df8b4d1
+        e4997bdd4b8202ff502a19173693c43f
+        870dae2d646cadeed1494f6271433499
     )
 ELSE(QT_FOUND)
     #xml++
@@ -60,6 +72,13 @@
         6fabac021e377efd35dede7198feefd4
         fe0cbb768e26aa12a0e03990f4f50a30
     )
+    SET(cifti_datatype_md5s
+        6db4a73e4e11a1ac0a5e7cbfb56eff40
+        f321156573ed8f165b208d84769bfd9a
+        794d60d9d397fe341e18313efeeac5ea
+        ea43725139bd3e152197fdf22c5e72e7
+        4dbb23ab2564ba8c9f242a3cb6036600
+    )
 ENDIF(QT_FOUND)
 
 #ADD_TEST(timer ${CMAKE_CURRENT_BINARY_DIR}/Tests/test_driver timer)
@@ -76,8 +95,16 @@
     ADD_TEST(rewrite-little-${testfile} rewrite ${CMAKE_SOURCE_DIR}/example/data/${testfile} little-${testfile} LITTLE)
     LIST(GET cifti_le_md5s ${index} goodsum)
     ADD_TEST(rewrite-little-md5-${testfile} ${CMAKE_COMMAND} -Dgood_sum=${goodsum} -Dcheck_file=little-${testfile} -P ${CMAKE_SOURCE_DIR}/cmake/scripts/testmd5.cmake)
+    SET_TESTS_PROPERTIES(rewrite-little-md5-${testfile} PROPERTIES DEPENDS rewrite-little-${testfile})
 
     ADD_TEST(rewrite-big-${testfile} rewrite ${CMAKE_SOURCE_DIR}/example/data/${testfile} big-${testfile} BIG)
     LIST(GET cifti_be_md5s ${index} goodsum)
     ADD_TEST(rewrite-big-md5-${testfile} ${CMAKE_COMMAND} -Dgood_sum=${goodsum} -Dcheck_file=big-${testfile} -P ${CMAKE_SOURCE_DIR}/cmake/scripts/testmd5.cmake)
+    SET_TESTS_PROPERTIES(rewrite-big-md5-${testfile} PROPERTIES DEPENDS rewrite-big-${testfile})
+    
+    ADD_TEST(datatype-${testfile} datatype ${CMAKE_SOURCE_DIR}/example/data/${testfile} datatype-${testfile})
+    LIST(GET cifti_datatype_md5s ${index} goodsum)
+    ADD_TEST(datatype-md5-${testfile} ${CMAKE_COMMAND} -Dgood_sum=${goodsum} -Dcheck_file=datatype-${testfile} -P ${CMAKE_SOURCE_DIR}/cmake/scripts/testmd5.cmake)
+    SET_TESTS_PROPERTIES(rewrite-big-md5-${testfile} PROPERTIES DEPENDS datatype-${testfile})
+    
 ENDFOREACH(index RANGE ${loop_end})

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,3 @@
-PROJECT(src)
 
 SET(HEADERS
 CiftiFile.h

=== src/Cifti/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,3 @@
-
-PROJECT(Cifti)
 
 SET(HEADERS
 CiftiXML.h

=== src/Nifti/CMakeLists.txt ===

SET(HEADERS
NiftiHeader.h
)

SET(SOURCES
NiftiHeader.cxx
)

=== debian/changelog ===
ciftilib (1.6.0-2) unstable; urgency=medium

  * Team Upload.
  * Do not (auto_)install anything in arch:all binary
    since this is only a doc package (Closes: #980852)

 -- Nilesh Patra <npatra974@gmail.com>  Sat, 23 Jan 2021 10:32:03 +0000

ciftilib (1.6.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Remove default debian/gbp.conf
  * Standards-Version: 4.5.1 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Set upstream metadata fields: Repository.
  * watch file standard 4 (routine-update)

 -- Andreas Tille <tille@debian.org>  Sun, 17 Jan 2021 15:26:15 +0100

ciftilib (1.5.3-4) unstable; urgency=medium

  * Team upload
  * Allow stderr output in autopkgtests for GCC warnings on armhf

 -- Graham Inggs <ginggs@debian.org>  Sun, 04 Oct 2020 12:35:25 +0000

=== debian/control ===
--- 
+++ 
@@ -1,20 +1,20 @@
 Source: ciftilib
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
 Section: libs
 Priority: optional
 Build-Depends: cmake,
-               debhelper-compat (= 12),
+               debhelper-compat (= 13),
                libboost-dev,
                libboost-filesystem-dev,
                libxml++2.6-dev,
                zlib1g-dev
 Build-Depends-Indep: doxygen
-Standards-Version: 4.4.1
+Standards-Version: 4.5.1
 Vcs-Browser: https://salsa.debian.org/med-team/ciftilib
 Vcs-Git: https://salsa.debian.org/med-team/ciftilib.git
 Homepage: https://github.com/Washington-University/CiftiLib
+Rules-Requires-Root: no
 
 Package: libcifti0
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -16,6 +16,12 @@
 override_dh_auto_build-indep:
 	dh_auto_build -- doc
 
+override_dh_auto_install-indep:
+	echo "DO NOTHING IN dh_auto_install in binary independent package since this only has docs"
+
+override_dh_install-indep:
+	echo "DO NOTHING IN dh_install in binary independent package since this only has docs"
+
 override_dh_installdocs-indep:
 	dh_installdocs --indep
 	dh_doxygen --indep

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/CiftiLib-$1\.tar\.gz/ \
https://github.com/Washington-University/CiftiLib/tags .*/v?(\d\S*)\.tar\.gz
